(*
 * fastpow : int * int -> int
 * REQUIRES: k >= 0
 * ENSURES: fastpow (n, k) ==> n^k (where 0^0 is defined as 1)
 *)
fun fastpow (n:int, k:int) : int = 
  if k = 0
  then 1 
  else 
  let 
    val subsoln = fastpow (n, k div 2) 
    val squared = subsoln * subsoln
  in 
    if k mod 2 = 0 
    then squared 
    else n * squared
  end

val 1 = fastpow (5, 0)
val 1 = fastpow (0, 0)
val 25 = fastpow (5, 2)
val 1 = fastpow (~1, 2)